module Hermes
  module RexClient
    class SyncStructuresTask

      def sync(client = Hermes::RexClient::Client.new, date)
        rex_last_updated = date || Setting.get_settings_for('rexclient').values['rex_last_updated']

        client.search_structures({'traceability.createdDate' => ">#{date}"}).each do |rex_entity|
          className = (rex_entity[:idEntityDefinition] == client.ed_entity) ? 'Hermes::Entity' : 'Hermes::Lessor'
          Hermes::RexClient::UpdateStructureTask.new.update_entity(client, rex_entity, className)
        end

        client.search_contacts({'traceability.createdDate' => ">#{date}"}).each do |rex_entity|
          Hermes::RexClient::UpdateContactTask.new.update_contact(client, rex_entity)
        end
      end
    end
  end
end
